<?php
namespace Ecommerce\Services;

use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class MeusProdutosService {

    protected $entityManager;
    protected $crudService;

    public function __construct(EntityManager $entityManager, $environment, $crudService) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->crudService = $crudService;
        $this->connection = $entityManager->getConnection();
    }
    
    public function saveImgDescriptionProd ($row) {
            $sql = "UPDATE PRODFORNCOMP SET DSIDFOTOFILESERV = :DSIDFOTOFILESERV, DSPRODUTO = :DSPRODUTO WHERE CDPRODCOMPL = :CDPRODUTO AND CDFORNECED = :CDFORNECED AND NRORG = :NRORG";
            $params = array(
                "DSIDFOTOFILESERV" => $row['DSIDFOTOFILESERV'],
                "DSPRODUTO"     => $row['DSPRODUTO'],
                "CDPRODUTO"   => $row['CDPRODUTO'],
                "CDFORNECED" => $row['CDFORNECED'],
                "NRORG"     => $this->environment->getNrorgTrab()
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
    }
    
    public function savePhotosAutomatic($path, $cdforneced, $cdarvprod, $useCodProdClie) {
        $product = $this->findProduct($cdforneced, $cdarvprod, $useCodProdClie);
        if($product){
            $sql = "UPDATE PRODFORNCOMP SET DSIDFOTOFILESERV = :DSIDFOTOFILESERV WHERE CDPRODCOMPL = :CDPRODCOMPL AND CDFORNECED = :CDFORNECED AND NRORG = :NRORG";
                $params = array(
                    "DSIDFOTOFILESERV" => $path,
                    "CDPRODCOMPL"   => $product,
                    "CDFORNECED" => $cdforneced,
                    "NRORG"     => $this->environment->getNrorgTrab()
                );
                
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return true;
        } else {
            return false;
        }
    }
    
    public function findProduct ($cdforneced, $cdarvprod, $useCodProdClie = true) {
        if (!$useCodProdClie) {
            $sql = "SELECT PF.CDPRODCOMPL FROM PRODFORNCOMP PF, PRODUTO P WHERE PF.CDFORNECED = :CDFORNECED AND P.CDARVPROD = :CDARVPROD AND PF.NRORG = :NRORG AND PF.CDPRODCOMPL = P.CDPRODUTO";
        } else {
            $sql = "SELECT CDPRODCOMPL FROM PRODFORNCOMP, PRODFORNXML WHERE PRODFORNXML.CDFORNECED = :CDFORNECED AND PRODFORNXML.CDPRODUTOXML = :CDARVPROD AND PRODFORNCOMP.NRORG = :NRORG AND PRODFORNCOMP.CDFORNECED = PRODFORNXML.CDFORNECED AND PRODFORNCOMP.CDPRODCOMPL = PRODFORNXML.CDPRODUTO";
        }
        
        $params = array(
            "CDFORNECED" => $cdforneced,
            "CDARVPROD"   => $cdarvprod,
            "NRORG"     => $this->environment->getNrorgTrab()
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $product = $std->fetchAll();
        if(empty($product)){
            return false;
        }else{
            $product = $product[0]['CDPRODCOMPL'];
            return $product;
        }
    }
    
    public function updateDescriptionProd ($cdforneced, $cdarvprod, $description) {
        $product = $this->findProduct($cdforneced, $cdarvprod, false);
        if($product){
            $sql = "UPDATE PRODFORNCOMP SET DSPRODUTO = :DSPRODUTO WHERE CDPRODCOMPL = :CDPRODCOMPL AND CDFORNECED = :CDFORNECED AND NRORG = :NRORG";
                $params = array(
                    "DSPRODUTO" => $description,
                    "CDPRODCOMPL"   => $product,
                    "CDFORNECED" => $cdforneced,
                    "NRORG"     => $this->environment->getNrorgTrab()
                );
                
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return true;
        }else{
            return false;
        }
    }
}